unit rapier_unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  t2port, t2video, cplist, math, mystrtool,
  StdCtrls, ExtCtrls,
  DirectShow9,ActiveX, JPEG;


type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    ComboBox1: TComboBox;
    RadioGroup1: TRadioGroup;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    RadioGroup2: TRadioGroup;
    Panel3: TPanel;
    CheckBox1: TCheckBox;
    Button1: TButton;
    Panel4: TPanel;
    CheckBox3: TCheckBox;
    Button2: TButton;
    Button3: TButton;
    procedure Form1show(Sender: TObject);
    procedure ListBox1click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox1select(Sender: TObject);
    procedure Form1create(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  MyPort:TComPort;
  cameras:TDeviceLinks;
  camera:IMoniker;

  rapiercfg:packed array[0..17] of word;


type
  TMyThread = class(TThread)
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: boolean);
  end;

var MyThread : TMyThread;


function GETTME(tpe:integer):string;

implementation

uses Unit2;

{$R *.dfm}

function GETTME(tpe:integer):string;
var tme:SYSTEMTIME;
begin
GETLOCALTIME(tme);
if tpe=1 then
result:=IntToStr(tme.wYear)+'.'+
               IntToStr(tme.wMonth)+'.'+
               IntToStr(tme.wDay)+' '+
               IntToStr(tme.wHour)+':'+
               IntToStr(tme.wMinute)+':'+
               IntToStr(tme.wSecond)+'';
if tpe=2 then
result:=IntToStr(tme.wYear)+'_'+
               IntToStr(tme.wMonth)+'_'+
               IntToStr(tme.wDay)+'___'+
               IntToStr(tme.wHour)+'_'+
               IntToStr(tme.wMinute)+'_'+
               IntToStr(tme.wSecond);

              
end;

procedure TMyThread.Execute;
var temp:TBufferType;
begin

  while (not Terminated) do
   begin

   // Oncoming FC FA SPD LEN
    if MyPort.GetData(1,temp,'FC',false) then
     begin
      Form1.Panel3.Caption:='--- km/h';
      Form1.Button2.Click;
     end;


    if MyPort.GetData(3,temp,'FA') and (Form1.Panel3.Caption='--- km/h')then
     begin
      Form1.Panel3.Caption:=IntToStr(temp[1])+' km/h';

      if Form1.ListBox1.Items.Count>100 then Form1.ListBox1.Clear;
      Form1.ListBox1.Items.Add(GETTME(1) + ' '+Form1.Panel3.Caption);

      form2.Image1.Canvas.TextOut(5,5,Form1.ListBox1.Items[Form1.ListBox1.Items.Count-1]);

      if Form1.checkBox1.checked then Form1.Button3.Click;

     end;


   // Outgoing FB FD SPD LEN
    if MyPort.GetData(1,temp,'FB',false) then
     begin
      Form1.Panel3.Caption:='--- km/h';
      Form1.Button2.Click;
     end;



    if MyPort.GetData(3,temp,'FD') and (Form1.Panel3.Caption='--- km/h')then
     begin

      Form1.Panel3.Caption:=IntToStr(temp[1])+' km/h';

      if Form1.ListBox1.Items.Count>100 then Form1.ListBox1.Clear;
      Form1.ListBox1.Items.Add(GETTME(1) + ' '+Form1.Panel3.Caption);


      form2.Image1.Canvas.TextOut(5,5,form1.ListBox1.Items[form1.ListBox1.Items.Count-1]);

      if Form1.checkBox1.checked then Form1.Button3.Click;

     end;




      sleep(50);
      Application.ProcessMessages;

   end;
end;

constructor TMyThread.Create(CreateSuspended: boolean);
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;


procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
    temp:TBufferType;
    rapierbincfg:TBufferType;
    txtcfg:string;
begin

 setbit16(rapiercfg[2],0,false); // 0 = km/h
 setbit16(rapiercfg[2],1,true);  // 1 = auto

  if radiogroup2.ItemIndex=1 then setbit16(rapiercfg[2],2,true) else  // 1 = across
                                  setbit16(rapiercfg[2],2,false);
  if radiogroup1.ItemIndex=1 then begin
                                   setbit16(rapiercfg[2],3,true);  //oncoming = off
                                   setbit16(rapiercfg[2],4,true);  //outgoing = on
                                  end else
                                  begin
                                   setbit16(rapiercfg[2],3,false);  //oncoming =  on
                                   setbit16(rapiercfg[2],4,false);  //outgoing = off
                                  end;

   for i := 5 to 15 do setbit16(rapiercfg[2],i,false);

  // ANGLE
  rapiercfg[5]:=Round(8193/cos(DegToRad(StrToIntDef(LabeledEdit1.Text,0))));

  // SPEED
  rapiercfg[14]:=StrToIntDef(LabeledEdit2.Text,0);


 MyPort.SendData('21 06 02');

     if myPort.GetDataLTime(1,temp,'06',50) then
      begin

     for i:=0 to 16 do
      begin
       rapierbincfg[i*2]:=rapiercfg[i] and $00ff;
       rapierbincfg[i*2+1]:=(rapiercfg[i] shr 8) and $00ff;
      end;

      txtcfg:='21 04';

      for i := 0 to 35-2 do txtcfg:=txtcfg+' '+IntToHex(rapierbincfg[i],2);

       MyPort.SendData(txtcfg);

       myPort.GetDataLTime(1,temp,'',50);

       if checkbox3.Checked then
        begin
         MyPort.SendData('21 06 05');
         MyPort.GetDataLTime(1,temp,'06',50);
        end;


         MyPort.SendData('21 06 01');
         MyPort.GetDataLTime(1,temp,'06',50);


         ShowMessage('Configuration written!');
       exit;

      end;

 ShowMessage('ERROR WRITING CONFIG!');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
with form2 do
 begin
  form2.Width:=gwidth;
  form2.Height:=gheight;

  if Image1.Width<>gwidth then
  Image1.Width:=gwidth;

  if Image1.Height<>gheight then
  Image1.Height:=gheight;
  GetBitmap1(Image1.Picture.Bitmap);

  Form1.Caption:=GETTME(2);
 end;

end;



procedure TForm1.Button3Click(Sender: TObject);
var JpegImage: TJpegImage;
   OutStream: TFileStream;
   dir,dir1,dir2:string;
   fname:string;
begin

dir:=ExtractFilePath(ParamStr(0))+'\photos\'+getWord(Form1.Caption,1,'_');
dir1:=getWord(Form1.Caption,2,'_');
dir2:=getWord(Form1.Caption,3,'_');
dir:=dir+'\'+dir1+'\'+dir2;

// ???
fname:=getWord(Form1.Caption,6,'_');
fname:=fname+'_'+getWord(Form1.Caption,7,'_');
fname:=fname+'_'+getWord(Form1.Caption,8,'_');

 if not ForceDirectories(dir) then
    raise Exception.Create('Cannot create '+dir);

//  mkDir(getWord(Form1.Caption,1,'_'));
  JpegImage := TJpegImage.Create;


  JpegImage.Assign(form2.Image1.Picture.Bitmap);
  try
    OutStream := TFileStream.Create(dir+'\'+{Form1.caption}fname+'.jpg',fmOpenWrite or fmCreate);
    JpegImage.SaveToStream(OutStream);
  finally
    OutStream.Free;
  end;
  JpegImage.Free;


  if checkbox1.Checked then
   ListBox1.Items[ListBox1.Items.Count-1]:=ListBox1.Items[ListBox1.Items.Count-1]+' * '+dir+'\'+fname+'.jpg';
   Form1.ListBox1.Perform(LB_SETTOPINDEX, Pred(Form1.ListBox1.Items.Count), 0);
end;

procedure TForm1.ComboBox1select(Sender: TObject);
begin
 ListBox1.Items.Add('Camera selected: '+ComboBox1.Items[ComboBox1.ItemIndex]);
 ComboBox1.Enabled:=false;

 camera:=DeviceNameToMoniker(ComboBox1.Items[ComboBox1.itemIndex],cameras);
 chooseVideoDevice( camera, Panel4.Handle,Panel4.ClientRect);
end;

procedure TForm1.Form1create(Sender: TObject);
var i,j:integer;
var portList:TStringList;
    temp:TBufferType;
begin

// form2.show;

// CAMERA
 ComboBox1.Items:=TStringList.Create;
 cameras:=EnumerateDevices(CLSID_VideoInputDeviceCategory);
 ComboBox1.Items:=DeviceLinksToStringList(cameras);

 if ComboBox1.Items.Count=1 then
  begin
   ComboBox1.ItemIndex:=0;
   ComboBox1.OnSelect(nil);
  end;


// COM PORT
 portList:=TStringList.Create;
 GetPortList(portList);

 for i := 0 to portList.Count-1 do
  begin
   myPort.OpenPort(portList[i]);

   myPort.SendData('21 06 02');

     if myPort.GetDataLTime(1,temp,'06',50) then
      begin

       MyPort.SendData('21 03');

       if myPort.GetDataLTime(35,temp,'10',50) then
       begin

        for j:=0 to 16 do
         rapiercfg[j]:=Byte(temp[j*2])+Byte(temp[j*2+1]) shl 8;

        if (rapiercfg[5]<>0) and (8192/rapiercfg[5]<=1) then
         LabeledEdit1.Text:=IntToStr(Round(RadToDeg(arccos(8193/rapiercfg[5]))))
        else LabeledEdit1.Text:='0';


        LabeledEdit2.Text:=IntToStr(rapiercfg[14]);


        Radiogroup1.ItemIndex:=-1;
        if (not getbit16(rapiercfg[2],3)) and (not getbit16(rapiercfg[2],4)) then Radiogroup1.ItemIndex:=0
         else
        if (getbit16(rapiercfg[2],3)) and (getbit16(rapiercfg[2],4)) then Radiogroup1.ItemIndex:=1;


        if not getbit16(rapiercfg[2],2) then RadioGroup2.ItemIndex:=0 else RadioGroup2.ItemIndex:=1;

        MyPort.SendData('21 06 01');
        MyPort.GetDataLTime(1,temp,'06',50);

        MyThread := TMyThread.Create(True);
        MyThread.Priority:=tpLower;
        MyThread.Resume;

        ListBox1.Items.Add('RADAR connected to '+portList[i]);

        exit; // RADAR FOUND


       end;



      end;

   myPort.ClosePort;
   Application.ProcessMessages;

  end;

  showMessage('Rapier not found!');
//  halt;
  Button1.Enabled:=false;
  

end;

procedure TForm1.Form1show(Sender: TObject);
begin
 form2.show;
end;

procedure TForm1.ListBox1click(Sender: TObject);
var ttt:string;
var JpegImage: TJpegImage;
    InStream: TFileStream;
begin



ttt:=ListBox1.Items[ListBox1.ItemIndex];


 if StrPos(PChar(ttt), '*') <> nil then
  begin
    form1.Caption:=getWord(ttt,2,'*');
    JpegImage := TJpegImage.Create;
    InStream := TFileStream.Create(trim(getWord(ttt,2,'*')),fmOpenRead);
    JpegImage.LoadFromStream(InStream);
    form2.Image1.Picture.Bitmap.Assign(JpegImage);
    InStream.Free;
    JpegImage.Free;
  end;


end;

end.
